# Zwei per Kommandozeile uebergebene Zahlen addieren
import sys

# Liste der Kommandozeilenparameter (args wird nur als Abkuerzung verwendet)
args = sys.argv


# Es muessen genau drei sein (erstes ist immer der Dateiname des Skriptes)
# mit raise kann ein Fehler gemeldet werden. Hier ist es der in Python
# bereits vorhandene Typ ValueError, dem noch eine aussagekraeftige
# Fehlermeldung mitgegeben wird. Wird der Fehler nicht abgefangen, bricht das
# Programm an dieser Stelle ab.
#
# Wir schimpfen letztendlich nur etwas und Beenden das Programm per SystemExit.
# Der Unterschied besteht darin, dass wir bei der zweiten Variante den Fehler
# nicht verfolgen koennen und nur die Warnung ausgegeben wird.

if len(args) != 3:
    #raise ValueError('Bitte genau zwei Zahlen angeben')
    print 'Bitte genau zwei Zahlen angeben'
    raise SystemExit


# Argumente kommen als strings an und muessen noch in Zahlen umgewandelt
# werden. Das kann aber schiefgehen, wenn ungueltige Argumente auftreten,
# z.B. 'Fahrrad'
#
# Dafuer gibt es das try - except Konstrukt. Wenn der Code im try: Block
# einen Fehler wirft, kann im except: Block darauf reagiert werden.
#
# Im Grunde genommen brauchen wir das hier nicht, da die Fehlermeldung in dem
# Falle bereits aussagekraeftig genug ist. Wenn das Argument nicht in einen
# float konvertiert werden kann, gibt es einen ValueError. Probe:
#
# >>> float('Fahrrad')

try:
    a = float(args[1])
    b = float(args[2])
except ValueError:
    print 'Es sollten schon zwei Zahlen sein...'
    raise SystemExit

# Wenn alles bis hierher gut gegangen ist:
print '%f + %f = %f' % (a, b, a+b)

# Das Skript kann nun in der Konsole aufgerufen werden, z.B.: 1_7.py 1 2