from PyQt4           import QtCore
from DuplicateFinder import DuplicateFinder

class SearchThread(QtCore.QThread):
    """\brief This class provides the search functionality as capsuled in a 
              separated thread.
    """
    
    
    def __init__(self, directory, parent = None):
        """\brief Constructor of the SearchThread class which sets up the 
                  the functionality of the thread.
        """
        QtCore.QThread.__init__(self, parent)
        self.df = DuplicateFinder(directory)
        
    
    def run(self):
        """\brief This method gets called once the thread is started.
                  Do not call this method on your own. Use the start() method
                  to start the thread!
        """
        self.df.run()
        self.emit(QtCore.SIGNAL("finished()"))
