'''
Created on 30.05.2011

@author: voigt


Pakete: sind gleichzusetzen mit Verzeichnissen
Module: sind gleichzusetzen mit Dateien
'''

#-------------------------------------------------------------------------------

'''
Grundform:

import <paket or module>

Damit stehen alle im Modul enthaltenen Klassen, Funktionen, Variablen etc. 
unter dem Namen des Moduls (= Dateiname) zur Verfuegung
'''

import modul_im_gleichen_verz
modul_im_gleichen_verz.SagHallo()


#-------------------------------------------------------------------------------

'''
Grundform mit Deklaration einer Kurzschreibweise:

import <paket or module> as <name> 
'''
import modul_im_gleichen_verz as mgv
mgv.SagHallo()






#-------------------------------------------------------------------------------

'''
Wenn man nur eine bestimme Klasse aus einem Modul importieren will

from <paket or module> import <klasse>

Dann steht die Klasse, Funktion, Variable direkt (ohne Praefix) zur Verfuegung.
Vorsicht: Wenn Klassen mit gleichem Namen aus verschiedenen Modulen importiert,
wird der Name immer wieder ueberschrieben, d.h. es steht nur die zuletzt 
importierte Klasse unter dem Namen bereit.
'''

from modul_im_gleichen_verz import SagHallo
SagHallo()

#-------------------------------------------------------------------------------

'''
auch hier kann man wieder eine Kurzschreibweise festlegen:

from <paket or module> import <klasse> as <name>
'''

from modul_im_gleichen_verz import SagHallo as hi
hi()





#-------------------------------------------------------------------------------

'''
Man kann auch alle in einem Modul enthaltenen Klassen etc. direkt 
importieren:
'''

from modul_im_gleichen_verz import *







#-------------------------------------------------------------------------------

'''
Bislang wurde nur aus einem Modul im gleichen Verzeichnis importiert. Der 
Zugriff auf Pakete und Module in Paketen erfolgt analog zur Verzeichnis-
struktur im Dateisystem, getrennt durch Punkte.

Importiert man ein Paket, stehen die darin enthaltenen Module (vorerst) nicht 
automatisch bereit!
'''

import paket
import paket.unterpaket


#-------------------------------------------------------------------------------

'''
Man importiert also wieder das Modul (= die Datei):
'''
import paket.modul_im_paket
paket.modul_im_paket.moin()

'''oder wieder mit Kurzform:'''
import paket.modul_im_paket as mip
mip.moin()

'''oder wieder nur die Funktion'''
from paket.modul_im_paket import moin
moin()
#-------------------------------------------------------------------------------

'''
Wichtig: der in den Modulen stehende Quelltext wird beim Importieren auch
ausgefuehrt, wie das folgende Beispiel zeigt:
'''

import paket.unterpaket.modul_im_unterpaket

'''
Hierbei wird die Zeile mit dem print-statement ganz normal ausgefuehrt, egal
in welcher Weise importiert wird.
'''

#-------------------------------------------------------------------------------


'''
Natuerlich kann dieses Verhalten trotzdem unterbunden werden, wie das naechste
Beispiel zeigt: 
'''

import paket.unterpaket.modul_im_unterpaket_silent

'''
Alles, was innerhalb der if-Anweisung steht, wird nur dann ausgefuehrt, wenn
das Modul direkt ausgefuehrt, also NICHT importiert wird
'''

#-------------------------------------------------------------------------------
