# -*- coding: utf-8 -*-


"""
Beispielskript zum Thema
 * Verteilungsfunktionen und Histogramm
"""


# Quelle
#http://matplotlib.sourceforge.net/examples/pylab_examples/scatter_hist.html


import numpy as np
import pylab as pl
from matplotlib.ticker import NullFormatter
import scipy.stats as stats


# the random data
x = np.random.randn(1000)
my_distr = stats.beta(3, 11)
x = my_distr.rvs(1000)
y = np.random.randn(1000)  # Normalverteilt

nullfmt   = NullFormatter()         # no labels

# realativ Koordinaten (zw. 0 und 1 auf das Fenster bezogen):
# definitions for the axes
left, width = 0.1, 0.65
bottom, height = 0.1, 0.65
bottom_h = left_h = left+width+0.02

rect_scatter = [left, bottom, width, height]
rect_histx = [left, bottom_h, width, 0.2]
rect_histy = [left_h, bottom, 0.2, height]

# start with a rectangular Figure
pl.figure(1, figsize=(8,8))

axScatter = pl.axes(rect_scatter)
axHistx = pl.axes(rect_histx)
axHisty = pl.axes(rect_histy)

# no labels
axHistx.xaxis.set_major_formatter(nullfmt)
axHisty.yaxis.set_major_formatter(nullfmt)

# the scatter plot:
axScatter.scatter(x, y)

# now determine nice limits by hand:
binwidth_x = 0.25
xmax = np.max(x)
xmin = np.min(x)
Dx   = xmax-xmin

binwidth_y = 0.25
ymax = np.max(np.fabs(y))
ylim = ( int(ymax/binwidth_y) + 1) * binwidth_y



axScatter.set_xlim( (xmin-Dx*0.05, xmax+Dx*0.05) )
axScatter.set_ylim( (-ylim, ylim) )

# bins kann entweder eine Liste der Grenzen oder eine int-Zahl (=Anzahl) sein
axHistx.hist(x, bins=35)

bins = np.arange(-ylim, ylim + binwidth_y, binwidth_y)
axHisty.hist(y, bins=bins, orientation='horizontal')

axHistx.set_xlim( axScatter.get_xlim() )
axHisty.set_ylim( axScatter.get_ylim() )

pl.savefig('bsp4_1.pdf')


pl.show()
 
