# -*- coding: utf-8 -*-


"""
Beispielskript zu den Themen
 * Substitution
 * numerische Formelauswertung
"""
import sympy as sp
import numpy as np
import pylab as pl


from ipHelp import IPS, ip_syshook



x = sp.Symbol('x')
a,b,c = sp.symbols('a b c') # verschiedene Wege Symbole zu erz.


term1 = a*b*sp.exp(c*x)

term2 = term1.subs(a, 1/b)
print term2
print term1.subs(a, a+1)

num_werte = {a:2.5, b:0.4, c:-8, x:.125}
print term1.subs(num_werte)

print term1.subs(num_werte).evalf()


f = a*x*sp.atan(b*x)*sp.exp(c+a*x)
f_xa = f.diff(x).diff(a) # beispielhafte Rechnung

f_xa_fnc = sp.lambdify((a,b,c,x), f, modules='numpy')

XX = np.linspace(-2, 2, 25)
YY = f_xa_fnc(0.4, 1.7, 3.2, XX)
print YY

pl.plot(XX, YY)
pl.show()



#IPS()