/* 
  Demo für serielle Kommunikation mit einem Mikrokontroller
*/

// include the library code:
#include <LiquidCrystal.h>

// initialize the library with the numbers of the interface pins
LiquidCrystal lcd(9, 8, 5, 4, 3, 2);

int dirA = 12;
int dirB = 13;  
int speedA = 10;
int speedB = 11; 

int ledPin =  6;


int hupePin = 1;

void setup()
{
  pinMode (dirA, OUTPUT);
  pinMode (dirB, OUTPUT);
  pinMode (speedA, OUTPUT); // Linker Motor
  pinMode (speedB, OUTPUT); // Rechter Motor
  
  pinMode(ledPin, OUTPUT);
  pinMode(hupePin, OUTPUT);
  
    // set up the LCD's number of rows and columns: 
  lcd.begin(20, 4);
  
  Serial.begin(9600);
  
}

byte heart = 0;
void loop()
{
  byte b1, b2, b3;
  
  // Herzschlag 
  digitalWrite(ledPin, heart); heart = 1-heart;
  
  
  if (Serial.available() < 3)
  {
    delay(100);
    return;
  
  }
  if (Serial.available() >= 3)
  {
    
    b1 = Serial.read();
    b2 = Serial.read();
    b3 = Serial.read();    
    
    if (b3 != '\n')
    { 
       error(b1,b2,b3);
       return;  
    }
    
    if (b1 == 'F')
    {
       forward(b2);
       return; 
    }
    
    if (b1 == 'B')
    {
       backward(b2);
       return; 
    }
    
    if (b1 == 'I')
    {
       init(b2);
       return; 
    }
    
    if (b1 == 'S')
    {
       sound();
       return; 
    }
    
    // offensichtlich war b1 ungültig
    error(b1,b2,b3);
    
  }
  
  delay(1000);
  return;
} 

void error(byte b1, byte b2, byte b3)
{
  lcd.setCursor(0, 1);
  lcd.print("fehler");
  
  lcd.print(b1);
  lcd.print('#');
  lcd.print(b2);
  lcd.print('#');
  lcd.print(b3);
}


void forward(byte b2)
{

  
  lcd.setCursor(0, 1);
  lcd.print("Vorwaerts ");
  lcd.print(int(b2), DEC);
  
  // richtung vorwärts
  digitalWrite (dirA, LOW);
  digitalWrite (dirB, HIGH);
  
  analogWrite (speedA, b2);
  analogWrite (speedB, b2);
  
  delay(250);
  
  analogWrite (speedA, 0);
  analogWrite (speedB, 0);
  

  Serial.print("OK F\n");
  
}  


void backward(byte b2)
{
  lcd.setCursor(0, 1);
  lcd.print("Rueckwaerts ");
  lcd.print(int(b2));
  
  
  // richtung rückwärts
  digitalWrite (dirA, HIGH);
  digitalWrite (dirB, LOW);
    
  analogWrite (speedA, b2);
  analogWrite (speedB, b2);


  delay(250);
  
  analogWrite (speedA, 0);
  analogWrite (speedB, 0);
  

  Serial.print("OK R\n");

}


void init(byte b2)
{
  // schreibt das bekommene Byte zurück um 
  // die Kommunikation zu prüfen
  // (Konsistenztest)
  Serial.write(b2);
  Serial.write(byte('\n'));  
}



void sound()
{
  
  Serial.end();
  
  
  digitalWrite(hupePin, 1);
  delay(100);
  digitalWrite(hupePin, 0);
  delay(100);
  digitalWrite(hupePin, 1);
  delay(100);
  digitalWrite(hupePin, 0);
  delay(150);
  digitalWrite(hupePin, 1);
  
  
  delay(100);
  Serial.begin(9600);
  Serial.flush();
 
}

